#!/usr/bin/perl 
##########################################################################
#                                                                        #
# Perl Script for Resend lost Accouting packet to portaone Repius Server #
#                                                                        #
# Switzernet(c)2011                                                      #
#                                                                        #
##########################################################################
# my modules
use strict;
use warnings;
use POSIX;
use Config::IniFiles;
use Switch;
use DBI;
##########################################################################
# Setting
my $lock_file = '/var/run/ast-registration.pid';
my $runas_user = 'root';
my $config_file = '/etc/astrad/config/switzer.conf';
##########################################################################
# Globals
my ($dbh1,$dbh2,$User,$Pass,$master_host,$master_user);
##########################################################################
#                             Initialization                             #
##########################################################################
# Check if already running
if( -e $lock_file ) {
	open(PID,$lock_file);
	my $pid=<PID>;
	close PID;
	chomp $pid;
	if( !-e "/proc/$pid" ) {
		print STDERR "Lock file present, but no process with pid=$pid.\n";
		die "Can't delete lock file $lock_file\n" if !unlink $lock_file;
		print STDERR "Lock file has been removed.\n";
	} else {
		die "Lockfile present, another copy is punning pid=$pid\n";
	}
}
my ($name, $passwd, $uid, $gid) = getpwnam($runas_user) or die "$runas_user not in passwd file";;
##########################################################################
# set C locale
POSIX::setlocale(LC_ALL, "C");
##########################################################################
# Become daemon
my $pid;
if( !defined($pid = fork()) ) {
    die "cannot fork: $!";
} elsif ($pid) {
    # Create lockfile, and finish parent process
    open(PID, "> $lock_file") || die "ast-registration.pl: Unable to create lockfile $lock_file\n";
    print PID "$pid";
    close PID;
    chown $uid, $gid, $lock_file;
    exit;
} else {
    # daemon
    setpgrp();
    select(STDERR); $| = 1;
    select(STDOUT); $| = 1;
}

##########################################################################
# Install signall handler
$SIG{INT} = \&safe_exit;
$SIG{QUIT} = \&safe_exit;
$SIG{TERM} = \&safe_exit;
$SIG{HUP} = \&load_config;
##########################################################################
# Drop privileges
setuid($uid);
$< = $uid;
$> = $uid;
##########################################################################
# Signal Handlers
sub safe_exit {
    unlink $lock_file ;
    exit;
}
##########################################################################
#                                FUNCTION                                #
##########################################################################
# Load config from mysql.conf
sub load_config {
    my $conf=Config::IniFiles->new(-file => $config_file);
    return 0 if !defined $conf ;
    $User  = $conf->val('ASTER_DB','DB_USER');
    $Pass  = $conf->val('ASTER_DB','DB_PASS');
    $master_host = $conf->val('DB3','DB_HOST');
    $master_user = $conf->val('DB3','DB_USER');
    return 1;
}
##########################################################################
# Astrad Radius DB connect
sub db_connect {
my $dbh = DBI->connect_cached("DBI:mysql:".$_[0].";host=".$_[1],$_[2],$_[3]);
return $dbh if $dbh ;
safe_exit();
}
##########################################################################
# 
sub exec_register {
my ($str,$stp)=(0,0);
my $req=' ';
my $sth = $dbh1->prepare("SELECT * FROM registration ORDER BY id LIMIT 30");
safe_exit() if !$sth->execute();
return 0 if  !$sth->rows;
while (my $result = $sth->fetchrow_hashref) {
    $str=$result->{id} if !$str;
    $stp=$result->{id};
    if ($result->{action} eq 'REGISTER') {
       $dbh2->do("CALL REGISTER ('".$result->{username}."','".$result->{domain}."','".$result->{ipaddr}."','".$result->{port}."','".$result->{expires}."','".$result->{register}."')");
       }
    elsif ($result->{action} eq 'UNREGISTER') {
       $req .= "(username='".$result->{username}."' AND domain='".$result->{domain}."' AND ipaddr='".$result->{ipaddr}."' AND port='".$result->{port}."' AND expires='".$result->{expires}."') OR ";
       }
    }
$sth->finish;
$dbh2->do("DELETE FROM location2 WHERE ".substr($req,0,length($req)-3)) if $req ne ' ';
$dbh1->do("DELETE FROM registration WHERE id BETWEEN $str AND $stp");
return 1;
}
##########################################################################
#                                 main()                                 #
##########################################################################
load_config();
for (my $i=0;;$i++) {
  $dbh1=db_connect("asterisk","localhost",$User,$Pass);
  $dbh2=db_connect("astrad",$master_host,$master_user,'');
  $i=0 if (exec_register() || $i>100000);
  sleep 1 if $i;
}
safe_exit();
##########################################################################
#                                  END                                   #
##########################################################################
